import pandas as pd

from mu_map.random_search.eval.params import parameter_groups
from mu_map.random_search.eval.util import filter_by_params, load_data, remove_outliers

data = load_data("cgan_random_search/")
n_total = len(data)

outlier_runs = pd.read_csv("cgan_random_search/outliers.csv")
outlier_runs = outlier_runs[outlier_runs["outlier"]]
outlier_runs = list(outlier_runs["run"])

data_outlier = dict(filter(lambda i: i[0] in outlier_runs, data.items()))
n_outlier = len(data_outlier)

print(
    f"There are {n_outlier} outlier runs in {n_total} total runs which is {100 * n_outlier / n_total:.2f}%"
)
print()
print(f"By Parameters:")
for param_label, param_groups in parameter_groups.items():
    param_label = " ".join(
        map(lambda _str: _str[0].upper() + _str[1:], param_label.split("_"))
    )
    print(f" - {param_label}")

    for label, value in param_groups.groups.items():
        n_outlier = len(filter_by_params(data_outlier, value, param_groups.keys))
        n_total = len(filter_by_params(data, value, param_groups.keys))
        print(
            f"   - {label:>12}: {str(n_outlier):>2}/{str(n_total):>2} = {100 * n_outlier / n_total:.2f}%"
        )
    print()
